
/*@ requires 0 <= n && \valid(a+(0..n-1));
    assigns \nothing;
    ensures \result == -1 ==> (\forall integer i; 0<= i < n ==> a[i] != v);
    ensures 0 <= \result < n ==> a[\result] == v;
    ensures -1 <= \result < n;
 */
int find(int n, const int a[], int v)
{
  int i;

  for (i=0; i < n; i++) {
    if (a[i] == v) {
      return i;
    }
  }

  return -1;
}

#define N 10

int main(void)
{
  int a[N] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
  int i, n, result;

  for (i=0; i < N; i++) {
    result = find(N, a, i);
    //@ assert result == i;
  }

  return 0;
}
